<template>
  <el-select
    clearable
    @clear="onClear"
    @change="onChange"
    v-model="selectedID"
    placeholder="Направление продаж"
  >
    <el-option
      v-for="sellingDirection in sellingDirections"
      :key="sellingDirection.id"
      :value="sellingDirection.id"
      :label="sellingDirection.name"
    >
      <span class="id">{{ sellingDirection.id }}</span>
      <span class="name">{{ sellingDirection.name }}</span>
    </el-option>
  </el-select>
</template>

<script lang="ts">
import { Component, Mixins } from "vue-property-decorator";
import { SellingDirection } from "@/interfaces/SellingDirection";
import { AxiosInstance } from "@/modules/AxiosInstance";
import ComponentMixin from "@/components/common/ComponentMixin";
import { AsyncRequestCatchException } from "@/decorators/AsyncExceptionCatch";

/**
 * Компонент - поле выбора направления продаж.
 */
@Component
export default class ComponentSelectSellingDirection extends Mixins(
  ComponentMixin
) {
  /**
   * @property { SellingDirection[] } sellingDirections коллекция направлений продаж.
   */
  private sellingDirections: SellingDirection[] = [];

  /**
   * @property { number | null } selectedID идентификатор выбранного направления продаж.
   */
  private selectedID: number | null = null;

  /**
   * @property {boolean} isDisabled - признак "элемент неактивен"
   */
  private isDisabled = true;

  /**
   * @property {string} eventName - название события, которое генерирует компонент.
   */
  private eventName = "on-selected-selling-direction";

  /**
   * Метод срабатывает после создания компонента.
   */
  protected created(): void {
    // Вызываем метод запроса коллекции направлений продаж
    this.requestSellingDirections();
  }

  /**
   * Метод запроса коллекции направлений продаж.
   */
  @AsyncRequestCatchException
  private async requestSellingDirections(): Promise<void> {
    // Очищаем коллекции
    this.clearAll();

    // Отправляем запрос
    const request = AxiosInstance.get(
      "media-plan-search-view/get-selling-directions"
    );

    // Ожидаем ответ на запрос
    const response = await request;

    // Если данных нет
    if (!response.data) return;
    if (!Array.isArray(response.data)) return;

    // Сохраняем коллекцию направлений продаж
    this.sellingDirections = response.data as SellingDirection[];

    // Преключаем флаг "элемент неактивен"
    this.isDisabled = false;
  }

  /**
   * Метод срабатывает при изменении значения поля выбора направления продаж.
   */
  private onChange(): void {
    const selectedSellingDirection = this.sellingDirections.find(
      (sellingDirection) => sellingDirection.id === this.selectedID
    );
    // Оповещаем подписчиков об изменении выбранного направления продаж
    this.notifyOthers(
      selectedSellingDirection ? selectedSellingDirection : null
    );
  }

  /**
   * Метод вызывается после нажатия на иконку "очистить" в поле выбора.
   */
  private onClear(): void {
    // Очищаем выбранное направление продаж
    this.selectedID = null;
    // Оповещаем подписчиков об изменении значения поля выбора
    this.notifyOthers(null);
  }

  /**
   * Метод оповещения подписчиков об изменении значения поля выбора.
   *
   * @property {SellingDirection|null} selectedSellingDirection выбранное направление продаж.
   */
  private notifyOthers(
    selectedSellingDirection: SellingDirection | null = null
  ): void {
    this.notify(this.eventName, selectedSellingDirection);
  }

  /**
   * Метод очистки свойств компонента.
   */
  private clearAll() {
    // Переключаем флаг "элемент неактивен"
    this.isDisabled = true;
    // Очищаем выбранное направление продаж
    this.selectedID = null;
    // Очищаем коллекцию известных направлений продаж
    this.sellingDirections.length = 0;
    // Оповещаем подписчиков о том, что направление не выбрано
    this.notifyOthers(null);
  }
}
</script>

<style lang="scss" scoped>
.el-select {
  width: 100%;
  margin-bottom: 2%;
}
</style>
